﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

using C1.C1Word;
using C1.C1Word.Objects;

namespace C1WordTest
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        private void button1_Click(object sender, EventArgs e)
        {
            C1WordDocument word = new C1WordDocument();
            word.LoadFromRtf(new System.IO.MemoryStream(Encoding.UTF8.GetBytes(Properties.Resources.test)));
            AddTextBeforeBookmark(word, word.MainSection.Content);
            using (SaveFileDialog sfd = new SaveFileDialog())
            {
                sfd.Filter = "RTF Files (*.rtf)|*.rtf|DOCX Files (*.docx)|*.docx";
                if (sfd.ShowDialog(this) == DialogResult.OK)
                {
                    word.Save(sfd.FileName);
                }
            }
        }
        private string AddTextBeforeBookmark(C1WordDocument c1Word, RtfInnerContent content, bool insert = true)
        {
            var text = string.Empty;
            for (int i = 0; i < content.Count; i++)
            {
                if (content[i] is RtfParagraph)
                {
                    text = AddTextBeforeBookmark(c1Word, ((RtfParagraph)content[i]).Content, false);
                }
                else if (content[i] is RtfBookmarkStart)
                {
                    var bookmark = content[i] as RtfBookmark;
                    switch (bookmark.Name)
                    {
                        case "bmk1":
                            text = "This is text inserted at BookMark1";
                            break;
                        case "bmk2":
                            text = "This is text inserted at BookMark2";
                            break;
                    }
                }
                if (insert && text != string.Empty)
                {
                    var paragraph = c1Word.GetParagraph(text);
                    content.Insert(i, paragraph);
                    text = string.Empty;
                    i++;
                }
            }
            return text;
        }
    }
}
